package SOFA.demos.cplayer;

public class ReadingUnitImpl implements ControlInterface {
  SOFA.Component.DCUP.DCUPComponentManagerImpl cm;

  DisplayInterface displayRequirment;
  SOFA.Connector.EEG.Types.DataStream.OutputStream audioRequirment;

  public ReadingUnitImpl(SOFA.Component.DCUP.DCUPComponentManagerImpl _cm) {
    cm = _cm;
  }

  private void setRequirement() throws SOFA.Component.NamingException {
    displayRequirment = (DisplayInterface) cm.getRequirement("display");
    audioRequirment = (SOFA.Connector.EEG.Types.DataStream.OutputStream) cm.getRequirement("audio");
  }

  public void init() {
    try {
      setRequirement();
    } catch (SOFA.Component.NamingException e) {
      throw new SOFA.SOFAnode.Run.SOFARuntimeException("Bad requirements", e);
    }
  }

  public void play() {
    System.out.println("ReadingUnit: play");
    displayRequirment.updateStatus("playing...");

    byte[] data=new byte[16];
    audioRequirment.write(data,16);
  }

  public void stop() {
    System.out.println("ReadingUnit: stop");
    displayRequirment.updateStatus("stop...");
  }

}
